#ifndef H_MISSILE
#define H_MISSILE

class Missile;

#include "Weapon.h"
#include "World.h"

class Missile: public Weapon{
	int state;
	World *world;
	double get_ship_weight(Ship *target);
	double rotate;
	double maxlen;
	int target_id;
    public:
        static double detonatingImpact;
        static double detonatingDamage;
        static double defaultRadius;
        static double defaultMass;
        static double defaultAngularMass;
	static double guessTime;
	static double huntDistance;
	static double maxAcceleration;
	static double maxHuntAcceleration;
	static double maxRotationalAcceleration;

	double lastGuess;

        double damage;


        virtual void timeNotify(double timeDelta);

        virtual int getType();
        virtual void doDamage(double impactDamage, double
                explosionDamage,int from, World* world);

        virtual void destroy(World* world); 
        virtual ~Missile();
        Missile(World *world);
        virtual void draw();

        static void initialize();
        virtual void serialize(std::vector<unsigned char>& destination);
        static Missile* deserialize(std::vector<unsigned char>::iterator&
            it);



};
#endif
