#ifndef H_PLAYER_STATISTICS
#define H_PLAYER_STATISTICS

#include <vector>
class Preferences;

class PlayerStatistics{
    public:
        void initialize(int playerCount);
        void addKill(int player);
        void addDeath(int player);
        void addDamage(int player, double totalDamage, double
                shipDamage, int to);
        void addShoot(int player);
        void write();
        double getScore(int player);
        void serialize(std::vector<unsigned char>& destination);
        void deserialize(std::vector<unsigned char>::iterator& it);
        void save(Preferences& preferences, std::string key);
        int playerCount;

    private:
        std::vector<int> kills;
        std::vector<int> deaths;
        std::vector<double> totalDamage;
        std::vector<double> shipDamage;
        std::vector<std::vector<double> > receivedShipDamage;
        std::vector<int> weaponsFired;
        
};

#endif
