#include "player.h"

    int now;
double timeDelta;

void init_game(){
 if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER)<0){
        Errors::_addError("Can't init SDL",Errors::ERROR);
        return;
    }
    Errors::_addError("SDL init done",Errors::NOTICE);

   int width=Preferences::_getInt("/video/resolution/width");
   int height=Preferences::_getInt("/video/resolution/height");
   int bitDepth=Preferences::_getInt("/video/resolution/depth");
    world.initialize("mapa.dat");
    ObjectGraphics::m.x1=0;
    ObjectGraphics::m.x2=width;
    ObjectGraphics::m.y1=height;
    ObjectGraphics::m.y2=0;
    ObjectGraphics::m.XSCALE=world.width;
    ObjectGraphics::m.YSCALE=world.height;
//    tmpWorld.initialize("mapa.dat");

   int flags=SDL_HWSURFACE|SDL_DOUBLEBUF;
    try {
        surface=Surface(SDL_SetVideoMode(width,height,bitDepth,flags),false);
    }catch(Exception &e){
        Errors::_addError(
                std::string("Can't init video mode") +
                e.what(),Errors::ERROR);
        return;
    }
    ObjectGraphics::surface=surface;
        
    Errors::_addError("Video mode OK",Errors::NOTICE);
    angle=0;

}

void think(WorldArrays &arrays,std::vector<PlayerResponse> &response){

    now=SDL_GetTicks();

    timeDelta=now-performanceTimer;
    performanceTimer=now;
    performanceDelta+=timeDelta;
    frames++;


    SDL_Event event;
    
    while ( SDL_PollEvent(&event) ) {
        switch (event.type) {
            case SDL_KEYDOWN:
                if (event.key.keysym.sym==SDLK_ESCAPE) {
                    SDL_Event event;
                    event.type=SDL_QUIT;
                    SDL_PushEvent(&event);
                }
                if (event.key.keysym.sym==SDLK_UP){
                  playerResponse.accelerationJets=1;
                }
                if (event.key.keysym.sym==SDLK_DOWN){
                  playerResponse.accelerationJets=-1;
                }
                if (event.key.keysym.sym==SDLK_LEFT){
                  angle+=M_PI/4;
                }
                if (event.key.keysym.sym==SDLK_RIGHT){
                  angle-=M_PI/4;
                  playerResponse.rotationJets=-1;
                }
                if (event.key.keysym.sym==SDLK_SPACE){
                  playerResponse.fireWeapon=1;
                  playerResponse.weaponSpeed=arrays.myShips[0].weaponSlots[1]->getMaxSpeed();
                  playerResponse.weaponAngle=0;
                  playerResponse.weaponAdditional=6;
                }
		if (event.key.keysym.sym==SDLK_LALT){
		  playerResponse.fireWeapon=2;
                  playerResponse.weaponSpeed=50;
                  playerResponse.weaponAngle=0;
                  playerResponse.weaponAdditional=0;

		}
		if(event.key.keysym.sym==SDLK_LCTRL){
		    playerResponse.fireWeapon=-1;
		}


                break;
            case SDL_KEYUP:
                if (event.key.keysym.sym==SDLK_UP ||
                        event.key.keysym.sym==SDLK_DOWN){
                  playerResponse.accelerationJets=0;
                }
                if (event.key.keysym.sym==SDLK_LEFT ||
                        event.key.keysym.sym==SDLK_RIGHT){
                  playerResponse.rotationJets=0;
                }
                if (event.key.keysym.sym==SDLK_SPACE) {
                  playerResponse.fireWeapon=-1;
                }

                break;


            case SDL_MOUSEMOTION:
                mouseX=event.motion.x;
                mouseY=event.motion.y;
                break;

	    case SDL_MOUSEBUTTONDOWN:
		if(event.button.button==SDL_BUTTON_LEFT){
			  playerResponse.fireWeapon=0;
		          playerResponse.weaponSpeed=50;
			  playerResponse.weaponAngle=0;
			  playerResponse.weaponAdditional=0;		
		}

		if(event.button.button==SDL_BUTTON_MIDDLE){
	                  playerResponse.fireWeapon=1;
		          playerResponse.weaponSpeed=arrays.myShips[0].weaponSlots[1]->getMaxSpeed();
			  playerResponse.weaponAngle=0;
			  playerResponse.weaponAdditional=6;
		}

		if(event.button.button==SDL_BUTTON_RIGHT){
		    playerResponse.fireWeapon=2;
                    playerResponse.weaponSpeed=50;
                    playerResponse.weaponAngle=0;
                    playerResponse.weaponAdditional=0;
		}
		break;

	    case SDL_MOUSEBUTTONUP:
		playerResponse.fireWeapon=-1;
		break;

            case SDL_QUIT:
		exit(0);
                return;
        }
    }
    for(unsigned int  i=0;i<response.size();i++){
///	std::cout<<mouseX<<" "<<myPoint.x<<std::endl;
//	std::cout<<mouseY<<" "<<myPoint.y<<std::endl;
//	Point myPoint(ObjectGraphics::m.x(arrays.myShips[i].position.x),-ObjectGraphics::m.y(arrays.myShips[i].position.y));
//	playerResponse.rotationJets=Utils::getShipRotationalJets(&arrays.myShips[i],Utils::getAngle(myPoint,Point(mouseX,-mouseY)));
         Utils::shipNavigate(arrays.myShips[i],playerResponse,Point(ObjectGraphics::m.inverseX(mouseX),ObjectGraphics::m.inverseY(mouseY+20*i)));
	 response[i]=playerResponse;
    }
    ObjectGraphics::begin();
    world.draw();
    ObjectGraphics::flip();
    if (++performanceCounter>=PERFORMANCE_LOOPS){
        performanceCounter=0;
        printf("fps: %f, object count %d, serial size %d\n",
                1000*PERFORMANCE_LOOPS/(performanceDelta+0.00001), 
                47,47);
        performanceDelta=0;

    }


}
