#include "player.h"
#include <vector>
#define MAX_SHIP		10
#define PI			3.141592653589793238462643383276

#define BLIZKO_C_DIERA		300
#define DALEJ_C_DIERA		400
#define VYP_MOTOR_RYCH		150
#define BLIZKO_PLAZMA 		80
#define DALEJ_PLAZMA		100
#define AUTOD_ZIVOT		5
#define AUTOD_VZD		50
#define REASONABLE_V		150
#define SLOW_CYCLES 		3000 
#define DELAY_PLASMA 		3000
#define ROZ_PLA_KAN 		150
#define ROZ_PLA_MIS		500
#define DO_PRDELE_CHANCE	5000
#define DO_PRDELE_CYCLES	3000
#define MIN_SPEED_PLASMA	70

std::vector <bool> plazma(MAX_SHIP,false);
std::vector <int> stop(MAX_SHIP,-1);
std::vector <int> smer(MAX_SHIP,0);
std::vector <int> plazmadelay(MAX_SHIP,0);
std::vector <int> doprdele(MAX_SHIP,0);

long int cyklus=0;

void init_game(){

}

void think(WorldArrays &world,std::vector<PlayerResponse> &response){
	//printf("%ld\n",++cyklus);
	for(unsigned int i=0; i<response.size(); ++i){
		PlayerResponse &playerResponse=response[i];

		playerResponse.accelerationJets=1;
		playerResponse.fireWeapon=-1;

		// Najdeme najblizsiu lod a ulozime ju do lod
		int lod=0;
		if (world.otherShips.size()>0) lod=0;
		else lod=-1;
		for (unsigned int j=0; j<world.otherShips.size(); ++j){
			if (Utils::distance(&world.myShips[i],&world.otherShips[j])<Utils::distance(&world.myShips[i],&world.otherShips[lod])){
				lod=j;
			}
		}

		//printf("1111111111111111111111111111111111111111111111111\n");
		// S nizkou pravdepodobnostou raz za cas pojde niekde uplne do prdele
/*		if (!((rand()%DO_PRDELE_CHANCE) || doprdele[i])){
			doprdele[i] = DO_PRDELE_CYCLES;
			double a = world.myShips[i].angle;
			double natocenie = Utils::normalizeAngle(a + ((rand()%2)*2 - PI));
			playerResponse.rotationJets = Utils::getShipRotationalJets(&world.myShips[i],natocenie);
			//!printf("Ideme DO PRDELE!\n");
		}
*/
		// Auto navigacia k najblizsej nepriatelskej lodi
//		if (!doprdele[i]){
			if (lod==-1) playerResponse.accelerationJets=1;
			else Utils::shipNavigate(world.myShips[i],playerResponse,world.otherShips[lod].position);
//		} else doprdele[i]--;

		// Strelba
		//  0 - plazma
		//  1 - kanon
		//  2 - missile (riad. strela)
		// -2 - autodestrukcia
		int vzdialenost=501;
		if (lod==-1) vzdialenost=1;
		else vzdialenost=Utils::distance(&world.myShips[i],&world.otherShips[lod]);
		//printf("222222222222222222222222222222222222222222222\n");
//		if ((world.myShips[i].live < AUTOD_ZIVOT) && (vzdialenost < AUTOD_VZD)){
//			playerResponse.fireWeapon = -2;
			//!printf("DIE, MF, DIE!!!\n");
//		} else if (!doprdele[i]) {
			bool moze_0=false;
			bool moze_1=false;
			bool moze_2=false;
			int zbran=-1;
			//printf("Rychlost: %f",world.myShips[i].velocity.length());
			if (world.myShips[i].weaponSlots[0]->getTimeToNextShoot()==0 && world.myShips[i].velocity.length() > MIN_SPEED_PLASMA)
				if (plazmadelay[i]){
					plazmadelay[i]--;
					//printf("; delay: %d\n",plazmadelay[i]);
				} else {
					//printf("; ide");
					moze_0=true;
				}
			//else {}//printf("; nejde\n");
			if (world.myShips[i].weaponSlots[1]->getTimeToNextShoot()==0) {moze_1=true; /*printf("kanon moze\n"); */} //else printf("kanon nemoze\n");
			if (world.myShips[i].weaponSlots[2]->getTimeToNextShoot()==0) moze_2=true;
			playerResponse.fireWeapon=-1;

			//printf("1aaaaaaaaaaaaaaaaaaaaaa\n");

		//	moze_0=false;

			if (moze_0 && !moze_1 && !moze_2) zbran=0;
			if (!moze_0 && moze_1 && !moze_2) zbran=1;
			if (!moze_0 && !moze_1 && moze_2) zbran=2;

			if ((vzdialenost>=ROZ_PLA_MIS || zbran==2) && moze_2){
				playerResponse.fireWeapon=2;
				playerResponse.weaponSpeed=world.myShips[i].weaponSlots[2]->getMaxSpeed();
				playerResponse.weaponAngle=0;
				playerResponse.weaponAdditional=0;
			}

			//printf("2aaaaaaaaaaaaaaaaaaaaaaaaa\n");

			if (((vzdialenost>=ROZ_PLA_KAN && vzdialenost < ROZ_PLA_MIS) || zbran==0) && moze_0){
				if(lod!=-1){
					plazmadelay[i] = DELAY_PLASMA;
					playerResponse.fireWeapon=0;
					//if (plazma[i] || world.myShips[i].velocity.length()>500){
						playerResponse.weaponSpeed = world.myShips[i].weaponSlots[0]->getMaxSpeed();
						//playerResponse.weaponSpeed = 1000;
						plazma[i]=false;
						//!printf("rychla plazma\n");
						//printf(" vypustena\n");
					/*} else {
						playerResponse.weaponSpeed = world.myShips[i].weaponSlots[0]->getMaxSpeed() * 4 / 5;
						plazma[i]=true;
						printf("pomala\n");
					}*/
					double cas = Utils::getTimeToDistance(&world.myShips[i], &world.otherShips[lod], Utils::distance(&world.myShips[i], &world.otherShips[lod]));
					Point naraz = Utils::getPosition(&world.otherShips[lod], cas);
					playerResponse.weaponAngle = - world.myShips[i].angle + Utils::getAngle(world.myShips[i].position, naraz);
//					playerResponse.weaponAdditional = 6;
				}
			} else {
				//printf(" nevypustena\n");
			}

			//printf("3aaaaaaaaaaaaaaaaaaaaaaaaa\n");

			if ((zbran==1 || (vzdialenost < ROZ_PLA_KAN /*&& vzdialenost < ROZ_PLA_MIS*/)) && moze_1){
				playerResponse.fireWeapon=1;
				playerResponse.weaponSpeed=world.myShips[i].weaponSlots[1]->getMaxSpeed();
				playerResponse.weaponAngle=0;
				playerResponse.weaponAdditional=6;
			}
//		}
		/*if (world.myShips[i].weaponSlots[2]->getNumberOfRemainingShoots()<world.myShips[i].weaponSlots[2]->getMaxEnergy()/world.myShips[i].weaponSlots[2]->getShootEnergy()/2){
			playerResponse.fireWeapon=-1;
		}*/

		//printf("3333333333333333333333333333333333333333\n");

		// Spomalenie rychlosti na kontrolovanych REASONABLE_V
		if (!stop[i]){
			if (world.myShips[i].velocity.length()>REASONABLE_V){
				//printf("Idem velkou rychlostou %f --> spomalujem\n",world.myShips[i].velocity.length());
				//playerResponse.accelerationJets=0;
				if (playerResponse.accelerationJets==1){
					playerResponse.accelerationJets=-1;
					smer[i]=-1;
				} else {
					if (playerResponse.accelerationJets==-1){
						playerResponse.accelerationJets=1;
						smer[i]=1;
					}
				}
				stop[i]=SLOW_CYCLES;
			}
		}
		if (stop[i]){
			if (world.myShips[i].velocity.length()>REASONABLE_V){
				//printf("Idem velkou rychlostou %f --> spomalujem\n",world.myShips[i].velocity.length());
				playerResponse.accelerationJets=smer[i];
			}
			--stop[i];
		}
		//printf("%d\n",stop[i]);
		//printf("Idem rychlostou %f\n",world.myShips[i].velocity.length());

		//playerResponse.rotationJets=0;

		//Uhybanie od najblizsej ciernej diery
		
		//printf("44444444444444444444444444444444444444\n");

		if (world.blackHoles.size()>0){
			int c_diera=0;
			for (unsigned int j=0; j<world.blackHoles.size(); ++j){
				if (Utils::distance(&world.myShips[i],&world.blackHoles[j])<Utils::distance(&world.myShips[i],&world.blackHoles[c_diera])){
					c_diera=j;
				}
			}
			if (Utils::distance(&world.myShips[i],&world.blackHoles[c_diera])<world.blackHoles[c_diera].radius+world.myShips[i].radius+DALEJ_C_DIERA){
				if (world.myShips[i].velocity.length()>VYP_MOTOR_RYCH) playerResponse.accelerationJets=0;
				//printf("priblizujem sa\n");
			}
			if (Utils::distance(&world.myShips[i],&world.blackHoles[c_diera])<world.blackHoles[c_diera].radius+world.myShips[i].radius+BLIZKO_C_DIERA){
				double a=Utils::getAngle(&world.myShips[i],&world.blackHoles[c_diera]);
				double natocenie=Utils::normalizeAngle(a+ PI );
				playerResponse.rotationJets=Utils::getShipRotationalJets(&world.myShips[i],natocenie);
				if (world.myShips[i].angle-Utils::getAngle(&world.myShips[i],&world.blackHoles[c_diera])<Utils::normalizeAngle( PI *3/4))
				if (world.myShips[i].angle-Utils::getAngle(&world.myShips[i],&world.blackHoles[c_diera])< PI * (double)1/4){
					playerResponse.accelerationJets=1;
					//printf("oproti\n");
				} else {
					playerResponse.accelerationJets=-1;
					//printf("havaria\n");
				}
				//printf("%f\n",Utils::getAngle(&world.myShips[i],&world.blackHoles[c_diera]));
				//printf("uz som blizko\n");
			}
			//printf("%f\n",world.myShips[i].velocity.length());
		}

		//Uhybanie od najblizsej plazmy
		/*int najplazma=-1;
		for (unsigned int j=0; j<world.plasmaBalls.size(); ++j){
			if (Utils::distance(&world.myShips[i],&world.plasmaBalls[j])<Utils::distance(&world.myShips[i],&world.plasmaBalls[lod])){
				najplazma=j;
			}
		}
		if (najplazma!=-1){
			if (Utils::distance(&world.myShips[i],&world.plasmaBalls[najplazma])<world.plasmaBalls[najplazma].radius+world.myShips[i].radius+DALEJ_PLAZMA){
				//if (world.myShips[i].velocity.length()>150) playerResponse.accelerationJets=0;
				//printf("priblizujem sa\n");
			}
			if (Utils::distance(&world.myShips[i],&world.plasmaBalls[najplazma])<world.plasmaBalls[najplazma].radius+world.myShips[i].radius+BLIZKO_PLAZMA){
				double a=Utils::getAngle(&world.myShips[i],&world.plasmaBalls[najplazma]);
				double natocenie=Utils::normalizeAngle(a+ PI );
				playerResponse.rotationJets=Utils::getShipRotationalJets(&world.myShips[i],natocenie);
				//playerResponse.accelerationJets=1;
				//if (world.myShips[i].angle-Utils::getAngle(&world.myShips[i], &world.plasmaBalls[najplazma]) < //Utils::normalizeAngle( PI *3/4))
				//if (world.myShips[i].angle-Utils::getAngle(&world.myShips[i],&world.plasmaBalls[najplazma])< PI /4){
				//	playerResponse.accelerationJets=1;
					//PRINtf("oproti\n");
				//} else {
				//	playerResponse.accelerationJets=-1;
					//printf("havaria\n");
				//}
				//printf("%f\n",Utils::getAngle(&world.myShips[i],&world.plasmaBalls[najplazma]));
				//printf("uz som blizko\n");
			}
		}*/
	}
}
