#include "player.h"
#include "Preferences.h"
#include "MyStringUtils.h"
#include "Random.h"

#define POSITIONS_FILE "formacia.dat"
#define MAX 10

#define SCALE 4

Preferences moveData;
Point target[MAX];
double randomAngle[MAX];
double randomDistance[MAX];

void init_game(){
    moveData.loadFromFile(POSITIONS_FILE);
    for (int q=0; q<MAX; q++) {
        randomAngle[q]=3.14/2; //Random::getCenteredDouble(0,0.5*M_PI);//(Random::getInt(2)*2-1)*3.14/2;
        randomDistance[q]=Random::getDouble(Ship::defaultRadius*2)+0.5*Ship::defaultRadius;
    }
}



void think(WorldArrays &world,std::vector<PlayerResponse> &response){
    int myID=world.myShips[0].player;

    FOR(i,MAX)  {
        
        std::string key="time" +
            MyStringUtils::intToString((int)world.actualTime)+"/positions/"+
            MyStringUtils::intToString(myID)+"/"+
            MyStringUtils::intToString(i)+"/pos";

        if (moveData.haveKey(key)) {
            target[i]=Point::getPointFromString(moveData.getString(key));
            target[i].x*=SCALE;
            target[i].y*=SCALE;

        }

        }


    double radius=world.myShips[0].radius;

    for (unsigned int i=0; i< world.myShips.size(); i++)
        world.otherShips.push_back(world.myShips[i]);

    for(unsigned int  i=0;i<response.size();i++){
             int ok=1;
             int acc=1;
        for (unsigned int j=0; j<world.otherShips.size(); j++) {
             DistanceTime
                 tmp=Utils::getMinimalDistance(&world.myShips[i],&world.otherShips[j]);

             int ook=1;
            if ((tmp.distance < randomDistance[i] && tmp.time<1.0)  ||
                 (Utils::distance(&world.myShips[i],&world.otherShips[j])<
                  randomDistance[i])) {
                ook=0;            
                double
                    a=Utils::getAngle(&world.myShips[i],&world.otherShips[j]);                
                a=Utils::normalizeAngle(a-world.myShips[i].angle);
                if (a<0) randomAngle[i]=-3.14/2; else
                    randomAngle[i]=3.14/2;

  //              if (std::abs(a)<M_PI*0.5) acc=-1;

            }

            if (world.myShips[i].ship==world.otherShips[j].ship &&
                    world.otherShips[j].player==myID) ook=1;
            ok=ok&ook;
                        
        }
            if (!ok) {
                double angle=Utils::getAngle(world.myShips[i].position,target[i]);

                response[i].accelerationJets=0.5*acc;

                angle+=randomAngle[i];
                response[i].rotationJets=Utils::getShipRotationalJets(&world.myShips[i],
                        angle);

            } else {

                Utils::shipNavigate(&world.myShips[i],&response[i],target[i]);
            }

    }


     for (int i=0; i<world.myShips.size(); i++) {
         if (Random::getInt(100)) continue;
         int w=Random::getInt(3);
         response[i].fireWeapon=w;
         response[i].weaponAngle=0;
         response[i].weaponSpeed=world.myShips[i].weaponSlots[w]->getMaxSpeed();
         

     }
}
