#include "PlayerResponse.h"
#include <algorithm>
#include "Serializer.h"

// {{{ PlayerResponse OK
void PlayerResponse::validate(){
  accelerationJets=std::max(accelerationJets,-1.0);
  accelerationJets=std::min(accelerationJets,1.0);

  rotationJets=std::max(rotationJets,-1.0);
  rotationJets=std::min(accelerationJets,1.0);
  fireWeapon=-1;
  weaponAngle=0;
  weaponSpeed=0;
  weaponAdditional=0;
}
// }}}

// {{{ serialize OK
void PlayerResponse::serialize(std::vector<unsigned char>&
        destination){
    Serializer::serializeFloat(destination,accelerationJets);
    Serializer::serializeFloat(destination,rotationJets);
    Serializer::serializeInt(destination,fireWeapon);
    Serializer::serializeFloat(destination,weaponAngle);
    Serializer::serializeFloat(destination,weaponSpeed);
    Serializer::serializeFloat(destination,weaponAdditional);
}
// }}}

// {{{ deserialize OK
PlayerResponse PlayerResponse::deserialize(std::vector<unsigned char>
            ::iterator& it){
    PlayerResponse res;
    res.accelerationJets=Serializer::deserializeFloat(it);
    res.rotationJets=Serializer::deserializeFloat(it);

    res.fireWeapon=Serializer::deserializeInt(it);
    res.weaponAngle=Serializer::deserializeFloat(it);
    res.weaponSpeed=Serializer::deserializeFloat(it);
    res.weaponAdditional=Serializer::deserializeFloat(it);
    return res;
}
// }}}

// {{{ PlayerResponse OK
PlayerResponse::PlayerResponse():accelerationJets(0),rotationJets(0){
}
// }}}
